#line 1 "dfa_x86.cpp"
//
// Copyright (c) 2003, 2017, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 8;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 1;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RAX_REGN, rax_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RREGN, rRegN_rule, c)
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, no_rax_rdx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, no_rcx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rdi_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, rRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rax_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rbx_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rcx_RegI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rdx_RegI_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REX_REGP, rex_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(R15_REGP, r15_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, any_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, rRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, rax_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, rbx_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, no_rax_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, no_rbp_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, rsi_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, no_rax_rbx_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, rdi_RegP_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGF, regF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGD, regD_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rdx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, rRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, no_rax_rdx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, no_rax_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, no_rcx_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rax_RegL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rcx_RegL_rule, c)
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    if(         
#line 3650 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
false
#line 216 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, rFlagsRegUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, rFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecS(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECS, vecS_rule, c)
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECD, vecD_rule, c)
    }
}
void  State::_sub_Op_VecX(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECX, vecX_rule, c)
    }
}
void  State::_sub_Op_VecY(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECY, vecY_rule, c)
    }
}
void  State::_sub_Op_VecZ(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECZ, vecZ_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2510 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512novl()
#line 265 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_reg_evex_special_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2496 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512vl()
#line 275 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2481 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 289 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2469 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 303 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2441 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512novl()
#line 319 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_reg_evex_special_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2428 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512vl()
#line 329 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2414 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 343 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2403 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1965 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 373 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1953 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 383 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1953 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 397 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1941 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 411 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 1930 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 425 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 439 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 1918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 453 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 1906 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 467 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1894 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 483 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1882 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1882 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 507 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1870 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 521 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 1859 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 535 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1847 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 549 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1847 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 563 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1835 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 577 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_2_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[0]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_RREGI_RREGI]+_kids[1]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__CMPLTMASK_RREGI_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_RREGI_RREGI) &&
        /*p*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__CMPLTMASK_RREGI_RREGI_RREGI]+_kids[1]->_cost[_SUBI_RREGI_RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cadd_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cadd_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI_IMMI_M1, _AddI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI_M1, _AddI__LoadI_memory__immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) &&
        (
#line 7033 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 707 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, decI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, decI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI1, _AddI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) &&
        (
#line 7007 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 746 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, incI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, incI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI, _AddI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDI_RREGI__LOADI_MEMORY_, _AddI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__RREGI, _AddI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, addI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, addI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL_RREGL_IMML_M1, _AddL_rRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML_M1, _AddL__LoadL_memory__immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) &&
        (
#line 7155 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 923 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, decL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, decL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML1];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML1, _AddL__LoadL_memory__immL1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMML1) &&
        (
#line 7129 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 943 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMML1]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, incL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, incL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__IMML32, _AddL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDL_RREGL__LOADL_MEMORY_, _AddL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDL__LOADL_MEMORY__RREGL, _AddL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, addL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, addL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ADDL__LSHIFTL_RREGL_IMMI2_IMML32, _AddL__LShiftL_rRegL_immI2_immL32_rule, c)
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, subP_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, subP_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, addP_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, addP_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, addP_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, addP_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4036 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0 && n->in(2)->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1193 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALEOFFSETNARROW, indPosIndexScaleOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScaleOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPPosIdxScaleOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___LSHIFTL__CONVI2L_RREGI__IMMI2, _AddP__DecodeN_rRegN___LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4019 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0 && n->in(2)->in(3)->as_Type()->type()->is_long()->_lo >= 0
#line 1251 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___CONVI2L_RREGI_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXOFFSETNARROW, indPosIndexOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPPosIdxOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_RREGI_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_CONVI2L_RREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___CONVI2L_RREGI_, _AddP__DecodeN_rRegN___ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4001 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1309 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSETNARROW, indIndexScaleOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxScaleOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN___LSHIFTL_RREGL_IMMI2, _AddP__DecodeN_rRegN___LShiftL_rRegL_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) &&
        
#line 3984 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1367 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALENARROW, indIndexScaleNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxScaleNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        
#line 3967 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1421 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[RREGL]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXNARROW, indIndexNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_RREGN__RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3950 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1433 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_RREGN__RREGL]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSETNARROW, indIndexOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffsetNarrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxOffNarrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxOffNarrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_RREGN__RREGL, _AddP__DecodeN_rRegN__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3934 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1491 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32NARROW, indOffset32Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP32Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaP32Narrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 3918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 1545 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8NARROW, indOffset8Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaP8Narrow_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3885 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_shift() == Address::times_8)
#line 1599 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDCOMPRESSEDOOPOFFSET, indCompressedOopOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indCompressedOopOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPCompressedOopOffset_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPCompressedOopOffset_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3868 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1653 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALEOFFSET, indPosIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPPosIdxScaleOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__LSHIFTL__CONVI2L_RREGI__IMMI2, _AddP_any_RegP__LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 3851 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(3)->as_Type()->type()->is_long()->_lo >= 0
#line 1711 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__CONVI2L_RREGI_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXOFFSET, indPosIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPPosIdxOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_RREGI_) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_CONVI2L_RREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__CONVI2L_RREGI_, _AddP_any_RegP__ConvI2L_rRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET, indIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxScaleOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP__LSHIFTL_RREGL_IMMI2, _AddP_any_RegP__LShiftL_rRegL_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_RREGI__IMMI2) &&
        
#line 3818 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->in(3)->in(1)->as_Type()->type()->is_long()->_lo >= 0
#line 1822 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_RREGI__IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXSCALE, indPosIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPPosIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPPosIdxScale_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxScale_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[RREGL]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_ANY_REGP_RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_ANY_REGP_RREGL]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET, indIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaPIdxOff_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP_ANY_REGP_RREGL, _AddP_any_RegP_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaP32_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP]+_kids[1]->_cost[IMML8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, leaP8_rule, c+110)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI, _AndI_rRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, and_cmpLTMask_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, and_cmpLTMask_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, and_cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, and_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_CMPLTMASK_RREGI_RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__CMPLTMASK_RREGI_RREGI, _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_RREGI_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_RREGI_RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__CMPLTMASK_RREGI_RREGI_RREGI, _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 9178 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2139 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9178 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2174 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 9163 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2209 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9163 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2244 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsrI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsrI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        (
#line 9118 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2279 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9118 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2314 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RREGI) &&
        (
#line 9105 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2349 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_SUBI_IMMI0_RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_IMMI0_RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9105 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2384 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_IMMI0_RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsiI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsiI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 9092 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9092 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2454 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI_IMMI_M1) &&
        (
#line 9078 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2489 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_XORI_RREGI_IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9078 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2524 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_RREGI_IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andnI_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andnI_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI, _AndI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI__LOADI_MEMORY_, _AndI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__RREGI, _AndI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI_65535, _AndI_rRegI_immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI_RREGI_IMMI_255, _AndI_rRegI_immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, andI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, andI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMU31];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMU31, _AndI__LoadI_memory__immU31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_65535, _AndI__LoadI_memory__immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_255, _AndI__LoadI_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2UB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI, _AndI__LoadUS_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI_255, _AndI__LoadUS_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMI, _AndI__LoadUB_memory__immI_rule, c)
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ANDL_RREGL_IMML32, _AndL_rRegL_immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_32BITS]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, zerox_long_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, zerox_long_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMML_32BITS]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convI2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9525 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2887 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9525 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2919 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL_IMML_M1) &&
        (
#line 9510 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2951 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_ADDL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9510 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 2983 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsrL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsrL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        (
#line 9465 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3015 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9465 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3047 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0_RREGL) &&
        (
#line 9452 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3079 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_SUBL_IMML0_RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBL_IMML0_RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9452 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3111 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBL_IMML0_RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsiL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsiL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL_IMML_M1) &&
        (
#line 9439 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3143 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_XORL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9439 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3175 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL_IMML_M1) &&
        (
#line 9425 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3207 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_XORL_RREGL_IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9425 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 3239 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_RREGL_IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andnL_rReg_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ANDL__LOADL_MEMORY__IMML32, _AndL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDL_RREGL__LOADL_MEMORY_, _AndL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ANDL__LOADL_MEMORY__RREGL, _AndL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_65535) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_255) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) &&
        (
#line 10934 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 3474 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, array_equalsC_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, array_equalsC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) &&
        (
#line 10918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 3491 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, array_equalsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, array_equalsB_rule, c)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ__LOADVECTOR_MEMORY_, _Binary_vecZ__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECZ_VECZ, _Binary_vecZ_vecZ_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY__LOADVECTOR_MEMORY_, _Binary_vecY__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX__LOADVECTOR_MEMORY_, _Binary_vecX__LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECX_VECX, _Binary_vecX_vecX_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY];
        DFA_PRODUCTION__SET_VALID(_BINARY_VECY_VECY, _Binary_vecY_vecY_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_VCMPPD) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_VCMPPD]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_VCMPPD_IMMI8, _Binary_cmpOp_vcmppd_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RSI_REGP) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RSI_REGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RSI_REGP, _Binary_rdi_RegP_rsi_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_RAX_REGI, _Binary_rsi_RegP_rax_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_IMMI, _Binary_rsi_RegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RDX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RDX_REGI, _Binary_rdi_RegP_rdx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RDX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RSI_REGP_RDX_REGI, _Binary_rsi_RegP_rdx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RDI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RDI_REGP]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RDI_REGP_RCX_REGI, _Binary_rdi_RegP_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGN]+_kids[1]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGN_RREGN, _Binary_rax_RegN_rRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGL_RREGL, _Binary_rax_RegL_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGI_RREGI, _Binary_rax_RegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGP]+_kids[1]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RAX_REGP_RREGP, _Binary_rax_RegP_rRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGL__LOADL_MEMORY_, _Binary_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGL_RREGL, _Binary_rRegL_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGP_RREGP, _Binary_rRegP_rRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGN_RREGN, _Binary_rRegN_rRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI__LOADI_MEMORY_, _Binary_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPUCF_RFLAGSREGUCF, _Binary_cmpOpUCF_rFlagsRegUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_RFLAGSREGU, _Binary_cmpOpU_rFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_RREGI_RREGI, _Binary_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_RFLAGSREG, _Binary_cmpOp_rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 1787 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Bool()->_test._test != BoolTest::overflow &&
            n->as_Bool()->_test._test != BoolTest::no_overflow
#line 3642 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_VCMPPD, cmpOp_vcmppd_rule, c)
    }
    if(         
#line 4199 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 3651 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF2, cmpOpUCF2_rule, c)
    }
    if(         
#line 4178 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 3662 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF, cmpOpUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(RREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, castX2P_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ANY_REGP) ) {
      unsigned int c = _kids[0]->_cost[ANY_REGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_ANY_REGP_, _CastP2X_any_RegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_RREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_RREGN_];
        DFA_PRODUCTION__SET_VALID(_CASTP2X__DECODEN_RREGN__, _CastP2X__DecodeN_rRegN___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_RREGP_, _CastP2X_rRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, castPP_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, checkCastPP_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RCX_REGL) && STATE__VALID_CHILD(_kids[1], RDI_REGP) &&
        (
#line 10663 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((ClearArrayNode*)n)->is_large()
#line 3862 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RCX_REGL]+_kids[1]->_cost[RDI_REGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_large_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RCX_REGL) && STATE__VALID_CHILD(_kids[1], RDI_REGP) &&
        (
#line 10631 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!((ClearArrayNode*)n)->is_large()
#line 3871 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RCX_REGL]+_kids[1]->_cost[RDI_REGP]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_CMoveVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 8194 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && UseAVX < 3 && n->as_Vector()->length() == 4
#line 3909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vcmov4D_reg_rule, c)
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_CMoveVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_VCMPPD_IMMI8) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 8178 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && UseAVX < 3 && n->as_Vector()->length() == 8
#line 3945 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_VCMPPD_IMMI8]+_kids[1]->_cost[_BINARY_VECY_VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vcmov8F_reg_rule, c)
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_memUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI__LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGI_RREGI]+200;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmovI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_memUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_memUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL__LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGL__LOADL_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGL_RREGL]+200;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, cmovL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, cmovP_regUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, cmovP_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGP_RREGP]+200;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, cmovP_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_RFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_RFLAGSREGUCF]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_regUCF_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_regUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_RFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_RFLAGSREGU]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_RFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_RREGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_RFLAGSREG]+_kids[1]->_cost[_BINARY_RREGN_RREGN]+200;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, cmovN_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, cmovN_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 11467 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() == NULL && (Universe::narrow_klass_base() == NULL)
#line 4402 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+_kids[1]->_cost[IMMN0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_mem_reg0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 11454 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() != NULL
#line 4411 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+_kids[1]->_cost[IMMN0]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMN0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testN_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMNKLASS) && STATE__VALID_CHILD(_kids[1], _LOADNKLASS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMNKLASS]+_kids[1]->_cost[_LOADNKLASS_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_mem_imm_klass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMNKLASS]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_imm_klass_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMN) && STATE__VALID_CHILD(_kids[1], _LOADN_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMN]+_kids[1]->_cost[_LOADN_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], IMMN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[IMMN]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], _LOADN_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[_LOADN_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+_kids[1]->_cost[RREGN]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compN_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_immCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+145;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_memCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpD_cc_reg_CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpD_cc_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpD_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_immCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+145;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_memCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGUCF) || _cost[RFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGUCF, cmpF_cc_reg_CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+145;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, cmpF_cc_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+275;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI__LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDL__LOADL_MEMORY__RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__LOADL_MEMORY__RREGL]+_kids[1]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_RREGL__LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_RREGL__LOADL_MEMORY_]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_RREGL_IMML32) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_RREGL_IMML32]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testL_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, compL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+275;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CMPLTMASK_RREGI_RREGI, _CmpLTMask_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpLTMask0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+400;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, cmpLTMask_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP]+_kids[1]->_cost[IMMP0]+1000;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, partialSubtypeCheck_vs_Zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 11372 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 4830 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_mem_reg0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 11359 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCompressedOops || (Universe::narrow_oop_base() != NULL)
#line 4841 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMP0]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, testP_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) &&
        (
#line 11334 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->in(2)->in(2)->bottom_type()->reloc() == relocInfo::none
#line 4858 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_mem_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RREGP]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compP_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testU_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compU_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, testUL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREGU) || _cost[RFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREGU, compUL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapB_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapS_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7352 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 4971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7327 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 4990 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapB_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapB_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapS_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapS_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapI_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7352 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5065 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapL_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7327 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5084 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapP_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapP_0_rule, c)
    }
}
void  State::_sub_Op_WeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndSwapN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndSwapN_0_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeB_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeS_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, compareAndExchangeI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, compareAndExchangeI_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) &&
        (
#line 7531 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5159 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, compareAndExchangeL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, compareAndExchangeL_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) &&
        (
#line 7569 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
VM_Version::supports_cx8()
#line 5177 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, compareAndExchangeP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, compareAndExchangeP_rule, c)
    }
}
void  State::_sub_Op_CompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGN_RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGN_RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGN, compareAndExchangeN_rule, c)
    }
}
void  State::_sub_Op_GetAndAddB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7585 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5219 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddB_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddS_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7608 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5242 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddS_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xaddI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xaddI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 7631 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5265 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddI_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xaddL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xaddL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        (
#line 7654 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_LoadStore()->result_not_used()
#line 5287 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xaddL_no_res_rule, c)
    }
}
void  State::_sub_Op_GetAndSetB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgB_rule, c)
    }
}
void  State::_sub_Op_GetAndSetS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgS_rule, c)
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xchgI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xchgI_rule, c)
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xchgL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xchgL_rule, c)
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, xchgP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, xchgP_rule, c)
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, xchgN_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, xchgN_rule, c)
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 3066 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->get_narrowcon() == 0
#line 5378 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMN0, immN0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGN, loadConN0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConN0_rule, c+100)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConN_rule, c+125)
      }
    }
   if ( /* RREGN KNOWN_VALID || */ _cost[RREGN] > 125) {
     DFA_PRODUCTION(RREGN, loadConN_rule, 125)
   }
   if ( /* RAX_REGN KNOWN_VALID || */ _cost[RAX_REGN] > 125) {
     DFA_PRODUCTION(RAX_REGN, loadConN_rule, 125)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadConNKlass_rule, c+125)
    }
     DFA_PRODUCTION(RREGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(RAX_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConD(const Node *n){
    {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+125+95)
    }
    if(         
#line 3217 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
jlong_cast(n->getd()) == 0
#line 5422 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION(REGD, loadConD0_rule, c+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, c+100+95)	  // overwrites higher cost rule
    }
   if ( /* REGD KNOWN_VALID || */ _cost[REGD] > 125) {
     DFA_PRODUCTION(REGD, loadConD_rule, 125)
   }
   if ( /* STACKSLOTD KNOWN_VALID || */ _cost[STACKSLOTD] > 125+95) {
     DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, 125+95)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+125+95)
    }
    if(         
#line 3196 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
jint_cast(n->getf()) == 0
#line 5446 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION(REGF, loadConF0_rule, c+100)	  // overwrites higher cost rule
        DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, c+100+95)	  // overwrites higher cost rule
    }
   if ( /* REGF KNOWN_VALID || */ _cost[REGF] > 125) {
     DFA_PRODUCTION(REGF, loadConF_rule, 125)
   }
   if ( /* STACKSLOTF KNOWN_VALID || */ _cost[STACKSLOTF] > 125+95) {
     DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, 125+95)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3269 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 65535
#line 5465 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 3259 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 255
#line 5473 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 3249 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 24
#line 5481 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 3240 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 16
#line 5489 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3018 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
 _n_get_int__ == 64 
#line 5497 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_64, immI_64_rule, c)
    }
    if(         
#line 3007 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
 _n_get_int__ == 32 
#line 5505 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 2996 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ >= 0
#line 5513 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMU31, immU31_rule, c)
    }
    if(         
#line 2985 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
(-32768 <= _n_get_int__) && (_n_get_int__ <= 32767)
#line 5521 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI16, immI16_rule, c)
    }
    if(         
#line 2975 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
(-0x80 <= _n_get_int__) && (_n_get_int__ < 0x80)
#line 5529 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
    }
    if(         
#line 2966 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 5537 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI2, immI2_rule, c)
    }
    if(         
#line 2955 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == -1
#line 5545 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2944 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 1
#line 5553 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI1, immI1_rule, c)
    }
    if(         
#line 2933 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_int__ == 0
#line 5561 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadConI0_rule, c+50)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadConI_rule, c+100)
      }
    }
   if ( /* RREGI KNOWN_VALID || */ _cost[RREGI] > 100) {
     DFA_PRODUCTION(RREGI, loadConI_rule, 100)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > 100+100) {
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 100+100)
   }
   if ( /* RAX_REGI KNOWN_VALID || */ _cost[RAX_REGI] > 100) {
     DFA_PRODUCTION(RAX_REGI, loadConI_rule, 100)
   }
   if ( /* NO_RCX_REGI KNOWN_VALID || */ _cost[NO_RCX_REGI] > 100) {
     DFA_PRODUCTION(NO_RCX_REGI, loadConI_rule, 100)
   }
   if ( /* RBX_REGI KNOWN_VALID || */ _cost[RBX_REGI] > 100) {
     DFA_PRODUCTION(RBX_REGI, loadConI_rule, 100)
   }
   if ( /* NO_RAX_RDX_REGI KNOWN_VALID || */ _cost[NO_RAX_RDX_REGI] > 100) {
     DFA_PRODUCTION(NO_RAX_RDX_REGI, loadConI_rule, 100)
   }
   if ( /* RCX_REGI KNOWN_VALID || */ _cost[RCX_REGI] > 100) {
     DFA_PRODUCTION(RCX_REGI, loadConI_rule, 100)
   }
   if ( /* RDX_REGI KNOWN_VALID || */ _cost[RDX_REGI] > 100) {
     DFA_PRODUCTION(RDX_REGI, loadConI_rule, 100)
   }
   if ( /* RDI_REGI KNOWN_VALID || */ _cost[RDI_REGI] > 100) {
     DFA_PRODUCTION(RDI_REGI, loadConI_rule, 100)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3289 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 65535
#line 5639 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_65535, immL_65535_rule, c)
    }
    if(         
#line 3279 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 255
#line 5647 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_255, immL_255_rule, c)
    }
    if(         
#line 3185 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 5655 "dfa_x86.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 3174 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 <= _n_get_long__ && _n_get_long__ < 0x80
#line 5663 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML_127, immL_127_rule, c)
    }
    if(         
#line 3163 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 10
#line 5671 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML10, immL10_rule, c)
    }
    if(         
#line 3153 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == -1
#line 5679 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 3143 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 1
#line 5687 "dfa_x86.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML1, immL1_rule, c)
    }
    if(         
#line 3132 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == 0L
#line 5695 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL0_rule, c+50)
    }
    if(         
#line 3121 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == (int) (_n_get_long__)
#line 5711 "dfa_x86.cpp"
 ) {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+70+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+70+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL32_rule, c+70)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+70) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL32_rule, c+70)
      }
    }
    if(         
#line 3110 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
_n_get_long__ == (unsigned int) (_n_get_long__)
#line 5743 "dfa_x86.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMUL32, immUL32_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+60+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+60+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConUL32_rule, c+60)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+60) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConUL32_rule, c+60)
      }
    }
    if(         
#line 3099 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
-0x80L <= _n_get_long__ && _n_get_long__ < 0x80L
#line 5775 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMML8, immL8_rule, c)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+150+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+150+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadConL_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+150) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadConL_rule, c+150)
      }
    }
   if ( /* RREGL KNOWN_VALID || */ _cost[RREGL] > 150) {
     DFA_PRODUCTION(RREGL, loadConL_rule, 150)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 150+100) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 150+100)
   }
   if ( /* NO_RAX_RDX_REGL KNOWN_VALID || */ _cost[NO_RAX_RDX_REGL] > 150) {
     DFA_PRODUCTION(NO_RAX_RDX_REGL, loadConL_rule, 150)
   }
   if ( /* NO_RAX_REGL KNOWN_VALID || */ _cost[NO_RAX_REGL] > 150) {
     DFA_PRODUCTION(NO_RAX_REGL, loadConL_rule, 150)
   }
   if ( /* NO_RCX_REGL KNOWN_VALID || */ _cost[NO_RCX_REGL] > 150) {
     DFA_PRODUCTION(NO_RCX_REGL, loadConL_rule, 150)
   }
   if ( /* RAX_REGL KNOWN_VALID || */ _cost[RAX_REGL] > 150) {
     DFA_PRODUCTION(RAX_REGL, loadConL_rule, 150)
   }
   if ( /* RCX_REGL KNOWN_VALID || */ _cost[RCX_REGL] > 150) {
     DFA_PRODUCTION(RCX_REGL, loadConL_rule, 150)
   }
   if ( /* RDX_REGL KNOWN_VALID || */ _cost[RDX_REGL] > 150) {
     DFA_PRODUCTION(RDX_REGL, loadConL_rule, 150)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3076 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->as_Type()->type()->reloc() == relocInfo::none
            && (n->get_ptr() >> 31) == 0
#line 5838 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP31, immP31_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+60+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP31_rule, c+60)
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadConP31_rule, c+60)
    }
    if(         
#line 3039 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->get_ptr() == 0
#line 5860 "dfa_x86.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+50) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadConP0_rule, c+50)
      }
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RREGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadConP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadConP_rule, c+100)
      }
    }
   if ( /* RREGP KNOWN_VALID || */ _cost[RREGP] > 100) {
     DFA_PRODUCTION(RREGP, loadConP_rule, 100)
   }
   if ( /* STACKSLOTP KNOWN_VALID || */ _cost[STACKSLOTP] > 100+100) {
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 100+100)
   }
   if ( /* ANY_REGP KNOWN_VALID || */ _cost[ANY_REGP] > 100) {
     DFA_PRODUCTION(ANY_REGP, loadConP_rule, 100)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > 100) {
     DFA_PRODUCTION(INDIRECT, loadConP_rule, 100)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > 100) {
     DFA_PRODUCTION(MEMORY, indirect_rule, 100)
   }
   if ( /* RAX_REGP KNOWN_VALID || */ _cost[RAX_REGP] > 100) {
     DFA_PRODUCTION(RAX_REGP, loadConP_rule, 100)
   }
   if ( /* RBX_REGP KNOWN_VALID || */ _cost[RBX_REGP] > 100) {
     DFA_PRODUCTION(RBX_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RAX_REGP KNOWN_VALID || */ _cost[NO_RAX_REGP] > 100) {
     DFA_PRODUCTION(NO_RAX_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RBP_REGP KNOWN_VALID || */ _cost[NO_RBP_REGP] > 100) {
     DFA_PRODUCTION(NO_RBP_REGP, loadConP_rule, 100)
   }
   if ( /* RSI_REGP KNOWN_VALID || */ _cost[RSI_REGP] > 100) {
     DFA_PRODUCTION(RSI_REGP, loadConP_rule, 100)
   }
   if ( /* NO_RAX_RBX_REGP KNOWN_VALID || */ _cost[NO_RAX_RBX_REGP] > 100) {
     DFA_PRODUCTION(NO_RAX_RBX_REGP, loadConP_rule, 100)
   }
   if ( /* RDI_REGP KNOWN_VALID || */ _cost[RDI_REGP] > 100) {
     DFA_PRODUCTION(RDI_REGP, loadConP_rule, 100)
   }
   if ( /* R15_REGP KNOWN_VALID || */ _cost[R15_REGP] > 100) {
     DFA_PRODUCTION(R15_REGP, loadConP_rule, 100)
   }
   if ( /* REX_REGP KNOWN_VALID || */ _cost[REX_REGP] > 100) {
     DFA_PRODUCTION(REX_REGP, loadConP_rule, 100)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10336 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseXmmI2D
#line 6131 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convXI2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10299 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmI2D
#line 6150 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10322 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseXmmI2F
#line 6166 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convXI2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 10276 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmI2F
#line 6185 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, convI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andI2L_rReg_imm65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andI2L_rReg_imm65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_RREGI_IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_RREGI_IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, andI2L_rReg_imm255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, andI2L_rReg_imm255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMU31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMU31]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immU31_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immU31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immI_65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUB2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUB2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_RREGI_, _ConvI2L_rRegI__rule, c)
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convL2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convL2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X__DECODEN_RREGN__) &&
        (
#line 6468 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 6617 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X__DECODEN_RREGN__]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convN2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_RREGP_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_RREGP_]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, convP2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) &&
        (
#line 11771 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6684 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_and_restoreMask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) &&
        (
#line 11754 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6693 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) &&
        (
#line 11736 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->has_vector_mask_set()
#line 6704 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_and_restoreMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) &&
        (
#line 11718 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) &&
        (
#line 11703 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6726 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) &&
        (
#line 11687 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!n->has_vector_mask_set()
#line 6737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6155 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCountLeadingZerosInstruction
#line 6750 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosI_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6143 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCountLeadingZerosInstruction
#line 6767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6192 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCountLeadingZerosInstruction
#line 6804 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosL_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6180 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCountLeadingZerosInstruction
#line 6821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countLeadingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6229 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCountTrailingZerosInstruction
#line 6858 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosI_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosI_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6217 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCountTrailingZerosInstruction
#line 6875 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6261 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCountTrailingZerosInstruction
#line 6912 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosL_bsf_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosL_bsf_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6249 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCountTrailingZerosInstruction
#line 6929 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, countTrailingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, countTrailingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(RAX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, CreateException_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        (
#line 6524 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 6986 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, decodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        (
#line 6507 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 7009 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
      if (STATE__NOT_YET_VALID(RREGP) || _cost[RREGP] > c) {
        DFA_PRODUCTION__SET_VALID(RREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANY_REGP) || _cost[ANY_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGP) || _cost[RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGP) || _cost[RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGP) || _cost[NO_RAX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RBP_REGP) || _cost[NO_RBP_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RSI_REGP) || _cost[RSI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RBX_REGP) || _cost[NO_RAX_RBX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGP) || _cost[RDI_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(R15_REGP) || _cost[R15_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(REX_REGP) || _cost[REX_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(REX_REGP, decodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) &&
        
#line 3902 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_shift() == 0
#line 7059 "dfa_x86.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(INDIRECTNARROW, indirectNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirectNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN];
        DFA_PRODUCTION__SET_VALID(_DECODEN_RREGN_, _DecodeN_rRegN__rule, c)
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGN) ) {
      unsigned int c = _kids[0]->_cost[RREGN]+100;
        DFA_PRODUCTION__SET_VALID(RREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, decodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2391 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7096 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2379 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7106 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2367 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7120 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2356 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7134 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2344 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7148 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2332 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 7162 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2320 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7178 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2308 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7188 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2296 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 7202 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2285 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7216 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2273 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7230 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2261 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 7244 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, divI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, divI_rReg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RAX_REGL) && STATE__VALID_CHILD(_kids[1], IMML10) ) {
      unsigned int c = _kids[0]->_cost[NO_RAX_REGL]+_kids[1]->_cost[IMML10]+(5+8)*100;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, divL_10_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, divL_10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+30*100+10*100;
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, divL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, divL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModI_rReg_divmod_rule, c)
    }
}
void  State::_sub_Op_DivModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModL_rReg_divmod_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, encode_iso_array_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, encode_iso_array_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 6496 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull
#line 7340 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 6480 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull
#line 7350 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
      if (STATE__NOT_YET_VALID(RREGN) || _cost[RREGN] > c) {
        DFA_PRODUCTION__SET_VALID(RREGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGN) || _cost[RAX_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeHeapOop_rule, c)
      }
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, encodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) &&
        (
#line 12075 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!Compile::current()->use_rtm()
#line 7373 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RBX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLock_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) &&
        (
#line 12059 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Compile::current()->use_rtm()
#line 7382 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RBX_REGP]+300;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastLockRTM_rule, c)
      }
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+_kids[1]->_cost[RAX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 2677 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 7401 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, fmaD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 2689 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA
#line 7413 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, fmaF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_HasNegatives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, has_negatives_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, has_negatives_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF2) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF2]+_kids[1]->_cost[RFLAGSREGUCF]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], RFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[RFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], RFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[RFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_rule, c)
      }
    }
}
void  State::_sub_Op_Jump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+350;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LSHIFTL_RREGL_IMMI2_IMML32) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LSHIFTL_RREGL_IMMI2_IMML32]+350;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_addr_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI2) &&
        (
#line 6574 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
false
#line 7485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI2]+350;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_offset_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI_32_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI, _LShiftI_no_rcx_RegI__SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI, _LShiftI_no_rcx_RegI__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_M1, _LShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NO_RCX_REGI_RCX_REGI, _LShiftI_no_rcx_RegI_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI8, _LShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI1, _LShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_16, _LShiftI_rRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_RREGI_IMMI_24, _LShiftI_rRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__RCX_REGI, _LShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI8, _LShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI1, _LShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, salI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, salI_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADUS_MEMORY__IMMI_24, _LShiftI__LoadUS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI_64_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI, _LShiftL_no_rcx_RegL__SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI, _LShiftL_no_rcx_RegL__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI_M1, _LShiftL_rRegL_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_NO_RCX_REGL_RCX_REGI, _LShiftL_no_rcx_RegL_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI8, _LShiftL_rRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI1, _LShiftL_rRegL_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__RCX_REGI, _LShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__IMMI8, _LShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__LOADL_MEMORY__IMMI1, _LShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, salL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, salL_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_RREGI_) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_RREGI_]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_RREGI__IMMI2, _LShiftL__ConvI2L_rRegI__immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_RREGL_IMMI2, _LShiftL_rRegL_immI2_rule, c)
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADD_MEMORY_, _LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5183 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseXmmLoadAndClearUpper
#line 7801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5170 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmLoadAndClearUpper
#line 7811 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, loadD_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADF_MEMORY_, _LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadKlass_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADNKLASS_MEMORY_, _LoadNKlass_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadNKlass_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadPLocked_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, loadP_rule, c)
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADN_MEMORY_, _LoadN_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGN, loadN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadS_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+200;
        DFA_PRODUCTION__SET_VALID(RREGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, maxI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, maxI_rReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_0_rule, c)
    }
}
void  State::_sub_Op_SetVectMaskI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 1822 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
Matcher::has_predicated_vectors()
#line 8014 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, setMask_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, setMask_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 6405 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Matcher::post_store_load_barrier(n)
#line 8056 "dfa_x86.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+200;
        DFA_PRODUCTION__SET_VALID(RREGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, minI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, minI_rReg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[NO_RAX_RDX_REGI]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, modI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, modI_rReg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], NO_RAX_RDX_REGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[NO_RAX_RDX_REGL]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, modL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, modL_rReg_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+125;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, MoveF2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 10520 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseXmmLoadAndClearUpper
#line 8233 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 10507 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseXmmLoadAndClearUpper
#line 8247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(RREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, MoveD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RREGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, loadSSL_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c+125) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, loadSSL_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2249 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8330 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2237 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8340 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2237 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8354 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2225 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8368 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2214 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8382 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2202 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8396 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2202 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8410 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2190 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8424 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2178 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8440 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2166 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8450 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2166 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8464 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2154 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8478 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2143 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8492 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2131 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8506 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2131 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8520 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2119 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8534 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RAX_REGL) && STATE__VALID_CHILD(_kids[1], RAX_REGL) ) {
      unsigned int c = _kids[0]->_cost[NO_RAX_REGL]+_kids[1]->_cost[RAX_REGL]+300;
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulHiL_rReg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI]+300;
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+300;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, mulI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, mulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32]+300;
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+350;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+300;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+300;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, mulL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, mulL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2574 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8818 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2562 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8828 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2550 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 8844 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2539 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8854 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_OnSpinWait(const Node *n){
    {
      unsigned int c = 200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, onspinwait_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__IMMI, _OrI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_RREGI__LOADI_MEMORY_, _OrI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__RREGI, _OrI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, orI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, orI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rorI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rorI_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rorI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rorI_rReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NO_RCX_REGI_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NO_RCX_REGI_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NO_RCX_REGI_RCX_REGI]+_kids[1]->_cost[_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI8) &&
        (
#line 8716 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9108 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI8) &&
        (
#line 8716 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9143 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_RREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_RREGI_IMMI_M1]+_kids[1]->_cost[_LSHIFTI_RREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_RREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI1]+_kids[1]->_cost[_URSHIFTI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rolI_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rolI_rReg_i1_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_ORL__LOADL_MEMORY__IMML32, _OrL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORL_RREGL__LOADL_MEMORY_, _OrL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_ORL__LOADL_MEMORY__RREGL, _OrL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_ANY_REGP_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_ANY_REGP_]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_castP2X_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _CASTP2X_ANY_REGP_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_CASTP2X_ANY_REGP_]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, orL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, orL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI_M1]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rorL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rorL_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI1]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rorL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rorL_rReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C64_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C64_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_NO_RCX_REGL_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+_kids[1]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_NO_RCX_REGL_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_NO_RCX_REGL_RCX_REGI]+_kids[1]->_cost[_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI8) &&
        (
#line 8861 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 9512 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI8]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI8) &&
        (
#line 8861 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 9544 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI8]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_RREGL_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_RREGL_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_RREGL_IMMI_M1]+_kids[1]->_cost[_LSHIFTL_RREGL_IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_RREGL_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_RREGL_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_RREGL_IMMI1]+_kids[1]->_cost[_URSHIFTL_RREGL_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rolL_rReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rolL_rReg_i1_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RAX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulI_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowAddL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowSubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RAX_REGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RAX_REGL]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowNegL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowSubL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_OverflowMulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RAX_REGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RAX_REGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RFLAGSREG) || _cost[RFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, overflowMulL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGP];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_RSI_REGP_RAX_REGP, _PartialSubtypeCheck_rsi_RegP_rax_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[RAX_REGP]+1100;
        DFA_PRODUCTION__SET_VALID(RDI_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(R15_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, partialSubtypeCheck_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 6296 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 9741 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 6284 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 9758 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 6322 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 9795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 6309 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UsePopCountInstruction
#line 9812 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5670 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==2
#line 9849 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5658 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==1
#line 9858 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5646 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==0
#line 9869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 5634 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
AllocatePrefetchInstr==3
#line 9880 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, i2s_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_RREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_RREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__RCX_REGI, _RShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI8, _RShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI1, _RShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, sarI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, sarI_rReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadI2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADUS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADUS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadUS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, loadS2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__RCX_REGI, _RShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__IMMI8, _RShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__LOADL_MEMORY__IMMI1, _RShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, sarL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, sarL_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(REGD, roundDouble_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(REGF, roundFloat_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REX_REGP) &&
        (
#line 12135 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
SafepointMechanism::uses_thread_local_poll()
#line 10270 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REX_REGP]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_tls_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGP) &&
        (
#line 12119 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Assembler::is_polling_page_far() && SafepointMechanism::uses_global_page_poll()
#line 10279 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_far_rule, c)
      }
    }
    if(         (
#line 12103 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!Assembler::is_polling_page_far() && SafepointMechanism::uses_global_page_poll()
#line 10289 "dfa_x86.cpp"
) ) {
      unsigned int c = 125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD) &&
        (
#line 2647 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 10302 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 2635 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 10312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 2623 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=2
#line 10326 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SqrtF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF) &&
        (
#line 2611 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 10342 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 2599 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 10352 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 2587 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE>=1
#line 10366 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 5914 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10386 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 5901 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseStoreImmI16
#line 10405 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI16]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 5888 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10414 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmC0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 5939 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10437 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM0_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGP_RREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGP_RREGP]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGI_RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGI_RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_RAX_REGL_RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_RAX_REGL_RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD0) &&
        (
#line 6027 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10468 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD0]+25;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD0) &&
        (
#line 6015 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
!UseCompressedOops || (Universe::narrow_oop_base() != NULL)
#line 10477 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD0]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD0_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF]+50;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF0) &&
        (
#line 5977 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10500 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF0]+25;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__IMMI]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI_IMMI0__LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, negI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 7046 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 10664 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI1) &&
        (
#line 7019 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 10675 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI_RREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__RREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__RREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) &&
        (
#line 5838 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL__LOADL_MEMORY__IMML32]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _URSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_URSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, shrL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__RCX_REGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__RCX_REGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__LOADL_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LSHIFTL__LOADL_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, salL_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL_IMML0__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL_IMML0__LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, negL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 7168 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 10877 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML1) &&
        (
#line 7141 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseIncDec
#line 10888 "dfa_x86.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incL_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML32) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML32]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL__LOADL_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL_RREGL__LOADL_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__RREGL) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__RREGL]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addL_mem_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML32]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML0) &&
        (
#line 5863 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10926 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmL0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGL]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP31) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP31]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP0) &&
        (
#line 5745 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseCompressedOops && (Universe::narrow_oop_base() == NULL) && (Universe::narrow_klass_base() == NULL)
#line 10949 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], ANY_REGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[ANY_REGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN0) &&
        (
#line 5795 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
Universe::narrow_oop_base() == NULL && Universe::narrow_klass_base() == NULL
#line 10972 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN0]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMNKLASS) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMNKLASS]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmNKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], RREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[RREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeNKlass_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RSI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RCX_REGI) &&
        (
#line 10733 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UL
#line 11003 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RSI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RDI_REGP_RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 10717 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LU
#line 11020 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareLU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareLU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 10701 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::UU
#line 11055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RDX_REGI) &&
        (
#line 10685 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
((StrCompNode*)n)->encoding() == StrIntrinsicNode::LL
#line 11090 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RCX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RDX_REGI]+100;
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compareL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compareL_rule, c)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_compress_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_compress_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RSI_REGP) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RSI_REGP]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 10870 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 11155 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofUL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 10853 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 11172 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_RAX_REGI) &&
        (
#line 10836 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 11207 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_RAX_REGI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 10808 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL)
#line 11242 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conUL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 10779 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU)
#line 11277 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conU_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_RSI_REGP_IMMI) &&
        (
#line 10750 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics && (((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL)
#line 11312 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[_BINARY_RSI_REGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexof_conL_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexof_conL_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_RDI_REGP_RDX_REGI) && STATE__VALID_CHILD(_kids[1], RAX_REGI) &&
        (
#line 10887 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseSSE42Intrinsics
#line 11349 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_RDI_REGP_RDX_REGI]+_kids[1]->_cost[RAX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RBX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, string_indexofU_char_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, string_indexofU_char_rule, c)
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RSI_REGP) && STATE__VALID_CHILD(_kids[1], _BINARY_RDI_REGP_RDX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RSI_REGP]+_kids[1]->_cost[_BINARY_RDI_REGP_RDX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, string_inflate_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2107 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11374 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2095 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11384 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2083 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11398 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 2072 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11412 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 2060 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11426 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 2048 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11440 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2036 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11456 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 2024 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11466 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 2012 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 11480 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 2001 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11494 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 1989 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11508 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 1977 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11522 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_RREGI_RREGI, _SubI_rRegI_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_64) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_64]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_64_RCX_REGI, _SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_RCX_REGI, _SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RCX_REGI, _SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0__LOADI_MEMORY_, _SubI_immI0__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, negI_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, negI_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_RREGI, _SubI_immI0_rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__IMMI, _SubI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__RREGI, _SubI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0_RREGL, _SubL_immL0_rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_SUBL_IMML0__LOADL_MEMORY_, _SubL_immL0__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[RREGL]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, negL_rReg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, negL_rReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_SUBL__LOADL_MEMORY__IMML32, _SubL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_SUBL__LOADL_MEMORY__RREGL, _SubL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, subL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, subL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMML32]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, subL_rReg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, subL_rReg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, subL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, subL_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RBP_REGP) && STATE__VALID_CHILD(_kids[1], RBX_REGP) ) {
      unsigned int c = _kids[0]->_cost[NO_RBP_REGP]+_kids[1]->_cost[RBX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RBP_REGP) && STATE__VALID_CHILD(_kids[1], RAX_REGP) ) {
      unsigned int c = _kids[0]->_cost[NO_RBP_REGP]+_kids[1]->_cost[RAX_REGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(R15_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ANY_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(RREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RBP_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RSI_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RBX_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(REX_REGP, tlsLoadP_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI_RCX_REGI, _URShiftI_no_rcx_RegI_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI1, _URShiftI_rRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI_32_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI__SUBI_IMMI_32_RCX_REGI, _URShiftI_no_rcx_RegI__SubI_immI_32_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGI]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NO_RCX_REGI__SUBI_IMMI0_RCX_REGI, _URShiftI_no_rcx_RegI__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI8, _URShiftI_rRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_RREGI_IMMI_M1, _URShiftI_rRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__RCX_REGI, _URShiftI__LoadI_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__IMMI8, _URShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI__LOADI_MEMORY__IMMI1, _URShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, shrI_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, shrI_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL_RCX_REGI, _URShiftL_no_rcx_RegL_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI1, _URShiftL_rRegL_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_64_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI_64_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL__SUBI_IMMI_64_RCX_REGI, _URShiftL_no_rcx_RegL__SubI_immI_64_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NO_RCX_REGL) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[NO_RCX_REGL]+_kids[1]->_cost[_SUBI_IMMI0_RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_NO_RCX_REGL__SUBI_IMMI0_RCX_REGI, _URShiftL_no_rcx_RegL__SubI_immI0_rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI8, _URShiftL_rRegL_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_RREGL_IMMI_M1, _URShiftL_rRegL_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RCX_REGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__RCX_REGI, _URShiftL__LoadL_memory__rcx_RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RCX_REGI) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RCX_REGI]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__IMMI8, _URShiftL__LoadL_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL__LOADL_MEMORY__IMMI1, _URShiftL__LoadL_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, shrL_rReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, shrL_rReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__IMMI, _XorI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI__LOADI_MEMORY_, _XorI_rRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__RREGI, _XorI__LoadI_memory__rRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[RREGI]+125;
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, xorI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, xorI_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], _ADDI_RREGI_IMMI_M1) &&
        (
#line 9148 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12157 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[_ADDI_RREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI_RREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], RREGI) &&
        (
#line 9148 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12192 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI_RREGI_IMMI_M1]+_kids[1]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        (
#line 9133 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12227 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDI__LOADI_MEMORY__IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) &&
        (
#line 9133 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12262 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, blsmskI_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, blsmskI_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_RREGI_IMMI_M1, _XorI_rRegI_immI_M1_rule, c)
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(_XORL__LOADL_MEMORY__IMML32, _XorL__LoadL_memory__immL32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORL_RREGL__LOADL_MEMORY_, _XorL_rRegL__LoadL_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL];
        DFA_PRODUCTION__SET_VALID(_XORL__LOADL_MEMORY__RREGL, _XorL__LoadL_memory__rRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[RREGL]+125;
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML32]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], RREGL) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, xorL_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, xorL_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], _ADDL_RREGL_IMML_M1) &&
        (
#line 9495 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12434 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[_ADDL_RREGL_IMML_M1]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_rReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL_RREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], RREGL) &&
        (
#line 9495 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12466 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL_RREGL_IMML_M1]+_kids[1]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_rReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) && STATE__VALID_CHILD(_kids[1], _ADDL__LOADL_MEMORY__IMML_M1) &&
        (
#line 9480 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12498 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+_kids[1]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDL__LOADL_MEMORY__IMML_M1) && STATE__VALID_CHILD(_kids[1], _LOADL_MEMORY_) &&
        (
#line 9480 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86_64.ad"
UseBMI1Instructions
#line 12530 "dfa_x86.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ADDL__LOADL_MEMORY__IMML_M1]+_kids[1]->_cost[_LOADL_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, blsmskL_rReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, blsmskL_rReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION__SET_VALID(_XORL_RREGL_IMML_M1, _XorL_rRegL_immL_M1_rule, c)
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5758 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 12568 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5758 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 12577 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5747 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 12588 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd64B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5724 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12599 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5724 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12608 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5713 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 32
#line 12619 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5713 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 32
#line 12630 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5701 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 32
#line 12641 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5690 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12652 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5679 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 32
#line 12663 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd32B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5656 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 12674 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5656 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 12683 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5645 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 12694 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5645 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 12705 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5633 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 12716 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5622 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 12727 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5611 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 12738 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5601 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 12749 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5578 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 12760 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5578 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 12769 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5567 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 12780 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5567 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 12791 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5555 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 12802 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5544 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 12813 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5533 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 12824 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5523 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 12835 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5500 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 12846 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5500 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 12855 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5489 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 12866 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5489 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 12877 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5477 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 12888 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5466 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 12899 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5455 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 12910 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5445 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 12921 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd4B_rule, c)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6083 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12934 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6083 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12943 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6072 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 12954 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6049 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 12965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6049 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 12974 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6038 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 12985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6038 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 12996 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6026 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 13007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6015 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 13018 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6004 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 13029 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5981 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 13040 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5981 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 13049 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5970 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 13060 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5970 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 13071 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5958 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 13082 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5947 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 13093 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5936 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 13104 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5926 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 13115 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5903 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 13126 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5903 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 13135 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5892 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 13146 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5892 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 13157 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5880 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 13168 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5869 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 13179 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5858 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 13190 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5848 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 13201 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5825 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 13212 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_evex_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5825 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 13221 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5814 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 13232 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 5814 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 13243 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5802 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 13254 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5791 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 13265 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5780 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 13276 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 5770 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 13287 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vadd2S_rule, c)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6192 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13300 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6192 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13309 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6181 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13320 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6170 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6170 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13340 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6159 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 13351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6148 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13362 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6148 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13371 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6137 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13382 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6127 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 13393 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6116 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13404 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6116 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13413 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6105 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13424 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6095 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 13435 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2I_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 4566 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13448 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd16I_reduction_reg_evex_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd16I_reduction_reg_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4538 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd8I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4514 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 13500 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4490 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13535 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd4I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4470 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 13570 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4449 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 13605 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsadd4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsadd4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4429 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13640 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd2I_reduction_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4411 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly()
#line 13675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvadd2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4392 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 2 && UseAVX == 0
#line 13710 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsadd2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsadd2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6269 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 13747 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6269 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 13756 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6258 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 13767 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6247 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13778 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6247 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13787 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6236 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 13798 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6225 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13809 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6225 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13818 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6214 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 13829 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6204 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 13840 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2L_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 4640 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13853 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd8L_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4617 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13869 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd4L_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4598 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 13901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvadd2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvadd2L_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6378 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13935 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6378 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13944 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6367 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 13955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6356 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13966 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6356 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13975 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6345 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 13986 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6334 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 13997 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6334 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14006 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6323 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14017 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6313 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 14028 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6302 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14039 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6302 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14048 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6291 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6281 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 14070 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 4783 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14083 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, radd16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4744 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14093 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, radd8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4721 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14107 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4698 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 14121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4683 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14135 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4668 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 14149 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsadd2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6455 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6455 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14174 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6444 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 14185 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vadd8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6433 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14196 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6433 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14205 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6422 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14216 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vadd4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6411 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14227 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6411 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14236 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6400 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 14247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6390 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 14258 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vadd2D_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 4907 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 14271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvadd8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 4884 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14281 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4869 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 14295 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4854 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 14309 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsadd2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6782 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 14325 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 6771 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 64
#line 14334 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub64B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6759 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 32
#line 14345 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6748 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14354 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6737 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 32
#line 14365 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6725 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 32
#line 14376 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6714 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14387 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 6703 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 32
#line 14398 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub32B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6691 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 14409 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6680 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 14418 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6669 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 14429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6657 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 14440 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6646 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 14451 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6635 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 14462 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6625 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 16
#line 14473 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6613 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 14484 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6602 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 14493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6591 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 14504 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6579 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 14515 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6568 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 14526 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6557 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 14537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6547 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 14548 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6535 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 14559 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6524 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 14568 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6513 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 14579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6501 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 14590 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_exex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6490 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 14601 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6479 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 14612 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6469 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14623 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub4B_rule, c)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7107 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14636 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7096 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 14645 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7084 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 14656 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7073 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 14665 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7062 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 14676 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7050 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 14687 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7039 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 14698 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7028 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 14709 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7016 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 14720 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7005 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 14729 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6994 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 14740 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6982 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 14751 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6971 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 14762 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6960 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 14773 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 6950 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 14784 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6938 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 14795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6927 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 14804 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6916 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 14815 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6904 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 14826 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6893 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 14837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6882 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 14848 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 6872 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 14859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6860 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 14870 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_mem_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6849 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 14879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 6838 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 14890 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6826 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 14901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6815 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 14912 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6804 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 14923 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 6794 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 14934 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsub2S_rule, c)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7216 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14947 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7205 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 14956 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7194 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14967 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7183 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 14976 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7172 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14987 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7161 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 14996 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7151 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 15007 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7140 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15018 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7129 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7119 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 15038 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2I_rule, c)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7293 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15051 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7282 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15060 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7271 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15071 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7260 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 15080 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7249 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15091 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7238 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15100 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7228 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 15111 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2L_rule, c)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7402 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15124 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7391 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15133 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7380 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15144 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7369 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 15153 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7358 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15164 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7347 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15173 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7337 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 15184 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7326 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15195 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7315 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15204 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7305 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 15215 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
      }
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7479 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15228 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7468 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 15237 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsub8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7457 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15248 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7446 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15257 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsub4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7435 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15268 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7424 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15277 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7414 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 15288 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsub2D_rule, c)
      }
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7806 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15301 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7806 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15310 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7795 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 15321 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7783 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 15332 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_evex_special_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7783 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 15341 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7772 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 15352 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_evex_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7772 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 15363 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7761 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 15374 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7761 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 15385 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7749 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 15396 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7738 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 15407 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7727 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 15418 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7715 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 15429 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_evex_special_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7715 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 15438 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7704 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 15449 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_evex_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7704 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 15460 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7693 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 15471 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7693 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 15482 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7681 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 15493 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7670 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 15504 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7659 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 15515 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7649 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 15526 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7637 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 15537 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_evex_special_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7637 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 15546 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7626 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 15557 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_evex_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7626 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 15568 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7615 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 15579 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7615 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 15590 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7603 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 15601 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7592 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 15612 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7581 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 15623 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7571 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 15634 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7559 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 15645 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_evex_special_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7559 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 15654 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7548 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 15665 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_evex_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7548 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 15676 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7537 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 15687 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_avx_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7537 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 15698 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_mem_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7525 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 15709 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7514 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 15720 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7503 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 15731 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 7493 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 15742 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vmul2S_rule, c)
      }
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7981 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15755 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7981 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15764 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7970 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 15775 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7959 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15786 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7959 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15795 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7948 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 15806 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7871 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15817 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7871 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15826 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7860 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 15837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7850 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 4
#line 15848 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7839 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7839 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15868 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7828 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 15879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7818 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && n->as_Vector()->length() == 2
#line 15890 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2I_rule, c)
      }
    }
}
void  State::_sub_Op_MulReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5060 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 15903 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul16I_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul16I_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5032 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15920 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul8I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul8I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5008 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 15955 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 4985 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 15990 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsmul4I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsmul4I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4965 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16025 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rvmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rvmul2I_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 4946 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE > 3 && UseAVX == 0
#line 16060 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(RREGI) || _cost[RREGI] > c) {
        DFA_PRODUCTION__SET_VALID(RREGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(RAX_REGI) || _cost[RAX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGI) || _cost[NO_RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RBX_REGI) || _cost[RBX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RBX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGI) || _cost[NO_RAX_RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGI) || _cost[RCX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGI) || _cost[RDX_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGI, rsmul2I_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDI_REGI) || _cost[RDI_REGI] > c) {
        DFA_PRODUCTION__SET_VALID(RDI_REGI, rsmul2I_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7937 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16097 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7937 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16106 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 7926 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8 && VM_Version::supports_avx512dq()
#line 16117 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7915 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16128 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7915 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16137 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 7904 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 4 && VM_Version::supports_avx512dq()
#line 16148 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7893 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16159 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 7893 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16168 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 7882 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 2 && VM_Version::supports_avx512dq()
#line 16179 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2L_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5134 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16192 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul8L_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul8L_reduction_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5111 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16208 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul4L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul4L_reduction_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5092 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && VM_Version::supports_avx512dq()
#line 16240 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(RREGL) || _cost[RREGL] > c) {
        DFA_PRODUCTION__SET_VALID(RREGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_RDX_REGL) || _cost[NO_RAX_RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_RDX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RAX_REGL) || _cost[NO_RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RAX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_RCX_REGL) || _cost[NO_RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(NO_RCX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RAX_REGL) || _cost[RAX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RAX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RCX_REGL) || _cost[RCX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RCX_REGL, rvmul2L_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(RDX_REGL) || _cost[RDX_REGL] > c) {
        DFA_PRODUCTION__SET_VALID(RDX_REGL, rvmul2L_reduction_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8090 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16274 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8090 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16283 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8079 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 16294 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8068 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16305 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8068 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16314 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8057 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16325 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8046 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16336 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8046 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16345 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8035 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16356 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8025 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 16367 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 8014 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16378 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8014 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16387 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 8003 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16398 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 7993 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 16409 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
      }
    }
}
void  State::_sub_Op_MulReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5277 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 16422 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGF, rvmul16F_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5238 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul8F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5215 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16446 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5192 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 16460 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul4F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5177 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16474 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rvmul2F_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 5162 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 16488 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, rsmul2F_reduction_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+95)
      }
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8167 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16504 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8167 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16513 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8156 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16524 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vmul8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8145 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16535 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8145 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16544 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8134 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16555 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vmul4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8123 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16566 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8123 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16575 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8112 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16586 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8102 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 16597 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vmul2D_rule, c)
      }
    }
}
void  State::_sub_Op_MulReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 5401 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2
#line 16610 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(REGD, rvmul8D_reduction_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 5378 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16620 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul4D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5363 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0
#line 16634 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rvmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 5348 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseSSE >= 1 && UseAVX == 0
#line 16648 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, rsmul2D_reduction_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+95) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+95)
      }
    }
}
void  State::_sub_Op_FmaVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 10703 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 16664 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 10690 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 16673 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 10677 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 16684 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 10664 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 16693 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 10650 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 16704 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 10637 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 2
#line 16713 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma2D_reg_rule, c)
      }
    }
}
void  State::_sub_Op_FmaVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ__LOADVECTOR_MEMORY_) &&
        (
#line 10781 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 16726 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _BINARY_VECZ_VECZ) &&
        (
#line 10768 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 16
#line 16735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_BINARY_VECZ_VECZ]+150;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vfma16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY__LOADVECTOR_MEMORY_) &&
        (
#line 10755 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 16746 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _BINARY_VECY_VECY) &&
        (
#line 10742 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 8
#line 16755 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_BINARY_VECY_VECY]+150;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vfma8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX__LOADVECTOR_MEMORY_) &&
        (
#line 10729 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 16766 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX__LOADVECTOR_MEMORY_]+150;
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _BINARY_VECX_VECX) &&
        (
#line 10716 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseFMA && n->as_Vector()->length() == 4
#line 16775 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_BINARY_VECX_VECX]+150;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vfma4F_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8310 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 16788 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8299 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 16
#line 16797 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8288 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16808 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8277 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 16817 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8266 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16828 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8255 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16837 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8245 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 16848 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8234 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16859 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 8223 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16868 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 8213 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 16879 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vdiv2F_rule, c)
      }
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8387 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16892 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 8376 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16901 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vdiv8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8365 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16912 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 8354 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16921 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vdiv4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 8343 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16932 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8332 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 16941 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 8322 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 16952 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vdiv2D_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8470 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16965 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8459 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 16974 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt8D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8448 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16985 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8437 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 16994 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt4D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8426 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17005 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8415 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17014 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt2D_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8558 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17027 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) &&
        (
#line 8547 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17036 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsqrt16F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8536 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17047 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) &&
        (
#line 8525 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 8
#line 17056 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsqrt8F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8514 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17067 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) &&
        (
#line 8503 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17076 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsqrt4F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) &&
        (
#line 8492 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17087 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) &&
        (
#line 8481 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17096 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsqrt2F_reg_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_rule, c)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], RREGI) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vshiftcnt_0_rule, c)
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8915 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8904 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17130 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8892 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 17141 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8881 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 17150 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8870 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 17161 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8858 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 17172 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8847 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 17183 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8836 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 17194 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8824 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 17205 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8813 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 17214 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8802 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 17225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8790 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 17236 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8779 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 17247 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8768 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 17258 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8758 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17269 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8748 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17280 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8736 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 17291 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8725 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 17300 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8714 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 17311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8702 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 17322 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8691 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 17333 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8680 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 17344 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8670 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17355 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8660 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17366 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8648 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 17377 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8637 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 17386 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8626 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 17397 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8614 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 17408 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8603 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 17419 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8592 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 17430 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8582 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8572 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 17452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsll2S_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9044 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9033 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 17474 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9022 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9011 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 17494 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9000 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17505 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8989 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 17514 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8979 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 17525 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8969 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 17536 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8958 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17547 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8947 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17556 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 8937 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 17567 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 8927 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 17578 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsll2I_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9131 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17591 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9120 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 17600 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsll8L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9109 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 17611 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9098 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 17620 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsll4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9087 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17631 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9076 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 17640 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9066 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 17651 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9056 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 17662 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsll2L_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10065 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10054 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 17684 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10042 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 17695 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10031 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 17704 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10020 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 16
#line 17715 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10008 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 17726 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9997 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 17737 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9986 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 17748 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9974 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 17759 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9963 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 17768 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9952 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 17779 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9940 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 17790 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9929 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 17801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 17812 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9908 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17823 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9898 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 17834 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9886 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 17845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9875 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 17854 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9864 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 17865 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9852 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 17876 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9841 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 17887 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9830 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 17898 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9820 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9810 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 17920 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9798 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 17931 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9787 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 17940 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9776 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 17951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9764 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 17962 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9753 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 17973 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9742 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 17984 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9732 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 17995 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9722 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18006 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsra2S_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10194 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18019 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10183 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18028 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsra16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10172 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18039 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10161 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18048 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsra8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10150 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18059 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10139 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18068 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10129 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 18079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10119 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 18090 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsra4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10108 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10097 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18110 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 10087 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10077 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18132 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsra2I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9492 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18145 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9481 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 32
#line 18154 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl32S_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9469 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 18165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9458 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 18174 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9447 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 18185 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9435 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 16
#line 18196 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9424 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 16
#line 18207 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9413 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx256only() && n->as_Vector()->length() == 16
#line 18218 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl16S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9401 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 18229 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9390 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 18238 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9379 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 18249 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9367 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 8
#line 18260 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9356 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 8
#line 18271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9345 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 8
#line 18282 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9335 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18293 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9325 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 8
#line 18304 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9313 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 18315 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9302 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 18324 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9291 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 18335 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9279 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 4
#line 18346 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9268 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 4
#line 18357 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9257 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 4
#line 18368 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9247 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18379 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9237 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 4
#line 18390 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl4S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9225 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 18401 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_evex_special_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9214 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 18410 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9203 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 18421 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_imm_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9191 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512nobw() && n->as_Vector()->length() == 2
#line 18432 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_evex_special_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9180 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avx512bw() && n->as_Vector()->length() == 2
#line 18443 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9169 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
VM_Version::supports_avxonly() && n->as_Vector()->length() == 2
#line 18454 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_reg_avx_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9159 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18465 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9149 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX == 0 && n->as_Vector()->length() == 2
#line 18476 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vsrl2S_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9621 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18489 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9610 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 16
#line 18498 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl16I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9599 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18509 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9588 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 8
#line 18518 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl8I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9577 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18529 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9566 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 4
#line 18538 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9556 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 18549 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9546 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 18560 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl4I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9535 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18571 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9524 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18580 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9514 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18591 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9504 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18602 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vsrl2I_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9708 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18615 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9697 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length() == 8
#line 18624 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vsrl8L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9686 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 18635 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9675 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length() == 4
#line 18644 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vsrl4L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9664 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18655 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9653 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length() == 2
#line 18664 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], IMMI8) &&
        (
#line 9643 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18675 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 9633 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 18686 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vsrl2L_rule, c)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10339 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18699 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10339 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18708 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10328 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18719 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vand64B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10317 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18730 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10317 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18739 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10306 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18750 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vand32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10295 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18761 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10295 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18770 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10284 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18781 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10274 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 18792 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vand16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10263 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 18803 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10263 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 18812 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10252 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 18823 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10242 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 18834 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vand8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10231 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 18845 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10231 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 18854 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10220 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 18865 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10210 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 18876 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vand4B_rule, c)
      }
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10481 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18889 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10481 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18898 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10470 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 18909 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vor64B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10459 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18920 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10459 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18929 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10448 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 18940 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vor32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10437 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10437 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18960 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10426 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 18971 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10416 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 18982 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vor16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10405 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 18993 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10405 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19002 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10394 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19013 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10384 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 19024 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vor8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10373 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19035 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10373 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19044 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10362 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19055 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10352 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 19066 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vor4B_rule, c)
      }
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10623 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECZ]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10623 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19088 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECZ) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 10612 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 2 && n->as_Vector()->length_in_bytes() == 64
#line 19099 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECZ]+_kids[1]->_cost[VECZ]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, vxor64B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10601 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19110 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECY]+100;
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10601 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19119 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 10590 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 1 && n->as_Vector()->length_in_bytes() == 32
#line 19130 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECY]+_kids[1]->_cost[VECY]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, vxor32B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10579 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19141 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECX]+100;
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10579 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19150 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10568 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 16
#line 19161 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECX) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 10558 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 16
#line 19172 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECX]+_kids[1]->_cost[VECX]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, vxor16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10547 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19183 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10547 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19192 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10536 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 8
#line 19203 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 10526 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 8
#line 19214 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, vxor8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADVECTOR_MEMORY_) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10515 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19225 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADVECTOR_MEMORY_]+_kids[1]->_cost[VECS]+100;
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], _LOADVECTOR_MEMORY_) &&
        (
#line 10515 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19234 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[_LOADVECTOR_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10504 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
UseAVX > 0 && n->as_Vector()->length_in_bytes() == 4
#line 19245 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VECS) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 10494 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length_in_bytes() == 4
#line 19256 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECS]+_kids[1]->_cost[VECS]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, vxor4B_rule, c)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADVECTOR_MEMORY_, _LoadVector_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2764 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() > 4
#line 19273 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_qword_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2751 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 64 && n->as_LoadVector()->element_size() <= 4
#line 19282 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, loadV64_dword_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2739 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 32
#line 19293 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECY, loadV32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2727 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 16
#line 19302 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECX, loadV16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2715 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 8
#line 19311 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 2703 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_LoadVector()->memory_size() == 4
#line 19320 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECS, loadV4_rule, c)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 2833 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() > 4
#line 19331 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_qword_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECZ) &&
        (
#line 2821 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 64 && n->as_StoreVector()->element_size() <= 4
#line 19340 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECZ]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV64_dword_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECY) &&
        (
#line 2810 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 32
#line 19351 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECY]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECX) &&
        (
#line 2799 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 16
#line 19362 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECX]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 2788 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 8
#line 19373 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECD]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECS) &&
        (
#line 2777 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_StoreVector()->memory_size() == 4
#line 19384 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECS]+145;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV4_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3818 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && UseAVX > 2
#line 19397 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3805 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && VM_Version::supports_avx512bw()
#line 19406 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3792 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512vlbw()
#line 19417 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3779 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19426 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3768 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && VM_Version::supports_avx512bw()
#line 19435 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3757 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 64 && VM_Version::supports_avx512bw()
#line 19446 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl64B_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3746 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512vlbw()
#line 19457 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3735 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512vlbw()
#line 19468 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3724 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19479 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3713 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19490 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3702 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vlbw()
#line 19501 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 3691 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vlbw()
#line 19510 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3430 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32
#line 19519 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3420 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 19530 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3410 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 19541 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3400 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 19552 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3389 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 19563 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3379 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 19574 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3364 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 19585 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3350 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 19596 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2947 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 19607 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 2935 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 19618 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 2919 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 19629 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2901 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && !VM_Version::supports_avx512vlbw()
#line 19640 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl32B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 2887 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 19651 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2871 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 19662 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl16B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 2859 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 19673 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) &&
        (
#line 2847 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 19684 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl4B_mem_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3957 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && UseAVX > 2
#line 19697 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3944 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512bw()
#line 19706 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3931 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19717 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3918 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vlbw()
#line 19726 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3907 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512bw()
#line 19735 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3896 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 32 && VM_Version::supports_avx512bw()
#line 19746 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl32S_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3885 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19757 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3874 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && VM_Version::supports_avx512vlbw()
#line 19768 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3863 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vlbw()
#line 19779 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3852 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vlbw()
#line 19790 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3841 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vlbw()
#line 19801 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3830 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vlbw()
#line 19810 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3507 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16
#line 19821 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3497 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 19832 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3487 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 19843 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3477 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 19854 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3466 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 19863 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3456 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 19874 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3443 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 19885 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECS) || _cost[VECS] > c) {
        DFA_PRODUCTION__SET_VALID(VECS, Repl2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3051 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 19896 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 3037 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 19907 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3021 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && !VM_Version::supports_avx512vlbw()
#line 19918 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl16S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3009 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 19929 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 2997 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 19940 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2983 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vlbw()
#line 19951 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl8S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) &&
        (
#line 2973 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vlbw()
#line 19962 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 2961 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vlbw()
#line 19973 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 4074 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 19986 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4061 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 19995 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4048 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vl()
#line 20006 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 4035 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20015 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4024 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20024 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 4013 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20035 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16I_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 4002 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vl()
#line 20046 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3991 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vl()
#line 20057 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3980 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20068 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3969 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20079 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3577 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8
#line 20090 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3567 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20101 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 3557 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20112 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3546 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20121 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3533 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20132 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3520 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20143 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3125 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20154 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 3113 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20165 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3101 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20176 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3087 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20187 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 3077 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 20198 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGI) &&
        (
#line 3065 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20209 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGI]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4I_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 4206 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20222 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4195 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20231 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4184 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20242 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 4173 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && VM_Version::supports_avx512vl()
#line 20251 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4160 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20260 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 4147 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20271 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 4099 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20282 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8L_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 4088 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20293 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 3645 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20304 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML0) &&
        (
#line 3635 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20315 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3622 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20326 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 3591 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20337 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3202 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20348 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) &&
        (
#line 3188 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20359 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], RREGL) &&
        (
#line 3154 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20370 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[RREGL]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 3140 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && !VM_Version::supports_avx512vlbw()
#line 20381 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2L_mem_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4298 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20394 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4286 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20403 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4274 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 20412 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 4262 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 20421 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4251 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20430 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4240 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 16 && UseAVX > 2
#line 20441 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl16F_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 4229 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vl()
#line 20452 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 4218 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && VM_Version::supports_avx512vl()
#line 20463 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 3668 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4
#line 20474 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 3658 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20485 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3280 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX < 3
#line 20496 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3270 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 20507 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 3260 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 20518 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3248 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20529 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 3236 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && !VM_Version::supports_avx512vl()
#line 20540 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl8F_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3226 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 20551 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl4F_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) &&
        (
#line 3216 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 20562 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_mem_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4378 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20575 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4366 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX > 2
#line 20584 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 4354 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 2
#line 20593 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_evex_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4343 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20602 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4332 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 8 && UseAVX > 2
#line 20613 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECZ) || _cost[VECZ] > c) {
        DFA_PRODUCTION__SET_VALID(VECZ, Repl8D_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 4321 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20624 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 4310 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && VM_Version::supports_avx512vl()
#line 20635 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_evex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 3679 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2
#line 20646 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3336 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && UseAVX < 3
#line 20657 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMD0) &&
        (
#line 3326 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX < 3
#line 20668 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD0]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3313 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20679 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 3301 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 4 && !VM_Version::supports_avx512vl()
#line 20690 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(VECY) || _cost[VECY] > c) {
        DFA_PRODUCTION__SET_VALID(VECY, Repl4D_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 3291 "/tmp/B.91cndgq9/BUILD/jdk10u-jdk-10.0.2+13/src/hotspot/cpu/x86/x86.ad"
n->as_Vector()->length() == 2 && UseAVX > 0 && !VM_Version::supports_avx512vl()
#line 20701 "dfa_x86.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(VECX) || _cost[VECX] > c) {
        DFA_PRODUCTION__SET_VALID(VECX, Repl2D_mem_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecS: { _sub_Op_VecS(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_VecX: { _sub_Op_VecX(n);
    break;
  }
  case Op_VecY: { _sub_Op_VecY(n);
    break;
  }
  case Op_VecZ: { _sub_Op_VecZ(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveVD: { _sub_Op_CMoveVD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveVF: { _sub_Op_CMoveVF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapB: { _sub_Op_CompareAndSwapB(n);
    break;
  }
  case Op_CompareAndSwapS: { _sub_Op_CompareAndSwapS(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_WeakCompareAndSwapB: { _sub_Op_WeakCompareAndSwapB(n);
    break;
  }
  case Op_WeakCompareAndSwapS: { _sub_Op_WeakCompareAndSwapS(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapN: { _sub_Op_WeakCompareAndSwapN(n);
    break;
  }
  case Op_CompareAndExchangeB: { _sub_Op_CompareAndExchangeB(n);
    break;
  }
  case Op_CompareAndExchangeS: { _sub_Op_CompareAndExchangeS(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_CompareAndExchangeN: { _sub_Op_CompareAndExchangeN(n);
    break;
  }
  case Op_GetAndAddB: { _sub_Op_GetAndAddB(n);
    break;
  }
  case Op_GetAndAddS: { _sub_Op_GetAndAddS(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetB: { _sub_Op_GetAndSetB(n);
    break;
  }
  case Op_GetAndSetS: { _sub_Op_GetAndSetS(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_DivModL: { _sub_Op_DivModL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_HasNegatives: { _sub_Op_HasNegatives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_Jump: { _sub_Op_Jump(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_SetVectMaskI: { _sub_Op_SetVectMaskI(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OnSpinWait: { _sub_Op_OnSpinWait(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_OverflowAddI: { _sub_Op_OverflowAddI(n);
    break;
  }
  case Op_OverflowSubI: { _sub_Op_OverflowSubI(n);
    break;
  }
  case Op_OverflowMulI: { _sub_Op_OverflowMulI(n);
    break;
  }
  case Op_OverflowAddL: { _sub_Op_OverflowAddL(n);
    break;
  }
  case Op_OverflowSubL: { _sub_Op_OverflowSubL(n);
    break;
  }
  case Op_OverflowMulL: { _sub_Op_OverflowMulL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_SqrtF: { _sub_Op_SqrtF(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddReductionVI: { _sub_Op_AddReductionVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddReductionVL: { _sub_Op_AddReductionVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddReductionVF: { _sub_Op_AddReductionVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_AddReductionVD: { _sub_Op_AddReductionVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulReductionVI: { _sub_Op_MulReductionVI(n);
    break;
  }
  case Op_MulVL: { _sub_Op_MulVL(n);
    break;
  }
  case Op_MulReductionVL: { _sub_Op_MulReductionVL(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulReductionVF: { _sub_Op_MulReductionVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_MulReductionVD: { _sub_Op_MulReductionVD(n);
    break;
  }
  case Op_FmaVD: { _sub_Op_FmaVD(n);
    break;
  }
  case Op_FmaVF: { _sub_Op_FmaVF(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_SqrtVD: { _sub_Op_SqrtVD(n);
    break;
  }
  case Op_SqrtVF: { _sub_Op_SqrtVF(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
